// Generated by CoffeeScript 1.4.0
var __slice = [].slice;

exports.postgres = function(engine) {
  var extensions, overrides;
  extensions = [];
  overrides = [];
  engine.extendQuery = function(query) {
    extensions.push('with');
    query["with"] = function(name, cte) {
      /*
            Usage (example from http://stackoverflow.com/a/3800572/446634)::
            
              select('summary', ['*']).where(rk: 1)
                .with('summary', select {p: 'purchases'}, ['id', 'customer', 'total'], ->
                  @fields func('row_number')
                  @over partition: ['customer'], order: [{rk: 'total DESC'}])
      
              WITH summary AS (
                  SELECT p.id, p.customer, p.total, ROW_NUMBER()
                    OVER(PARTITION BY p.customer ORDER BY p.total DESC) AS rk
                    FROM PURCHASES p)
              SELECT s.*
                FROM summary s
               WHERE s.rk = 1
      */

      var _ref;
      return ((_ref = this.ctes) != null ? _ref : this.ctes = {})[name] = cte;
    };
    overrides.push('render');
    query.render = function() {
      var alias, args, q;
      args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
      if (!this.ctes) {
        return this._override.render.apply(this, args);
      }
      "WITH " + ((function() {
        var _ref, _results;
        _ref = this.ctes;
        _results = [];
        for (alias in _ref) {
          q = _ref[alias];
          _results.push("" + alias + " AS (" + (q.render.apply(q, args)));
        }
        return _results;
      }).call(this)).join("\n") + "\n";
      return this._override.render.apply(this, args);
    };
    overrides.push('compile');
    return query.compile = function() {
      var cte, params, _, _ref;
      if (!this.ctes) {
        return this._override.compile.apply(this, arguments);
      }
      params = this.q.params();
      _ref = this.ctes;
      for (_ in _ref) {
        cte = _ref[_];
        params = cte.q.params().concat(params);
      }
      return [this.render(), params];
    };
  };
  return engine.unextendQuery = function(query) {
    var name, _i, _j, _len, _len1, _results;
    for (_i = 0, _len = extensions.length; _i < _len; _i++) {
      name = extensions[_i];
      delete query[name];
    }
    _results = [];
    for (_j = 0, _len1 = overrides.length; _j < _len1; _j++) {
      name = overrides[_j];
      _results.push(query[name] = query.constructor.prototype[name]);
    }
    return _results;
  };
};
